"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ControlKeys = void 0;
var react_1 = __importDefault(require("react"));
var IconButton_1 = __importDefault(require("@mui/material/IconButton"));
var createStyles_1 = __importDefault(require("@mui/styles/createStyles"));
var makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
var icons_1 = require("../icons");
var useStyles = (0, makeStyles_1.default)(function () {
    return (0, createStyles_1.default)({
        controls: {
            display: 'flex',
            alignItems: 'center',
        },
    });
});
var ControlKeys = function (props) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    var _r = props.color, color = _r === void 0 ? 'primary' : _r;
    var classes = useStyles(props);
    return (react_1.default.createElement("div", { className: classes.controls },
        props.backward !== undefined &&
            react_1.default.createElement(IconButton_1.default, __assign({ color: color, disabled: props.backward === false, "aria-label": "Backward", onClick: props.onBackwardClick }, (_a = props.BackwardProps) === null || _a === void 0 ? void 0 : _a.attributes, { size: "large" }), ((_c = (_b = props.BackwardProps) === null || _b === void 0 ? void 0 : _b.icons) === null || _c === void 0 ? void 0 : _c[0]) || react_1.default.createElement(icons_1.Rewind, null)),
        react_1.default.createElement(IconButton_1.default, __assign({ color: color, "aria-label": "Stop", onClick: props.onStopClick }, (_d = props.StopProps) === null || _d === void 0 ? void 0 : _d.attributes, { size: "large" }), ((_f = (_e = props.StopProps) === null || _e === void 0 ? void 0 : _e.icons) === null || _f === void 0 ? void 0 : _f[0]) || react_1.default.createElement(icons_1.Stop, null)),
        react_1.default.createElement(IconButton_1.default, __assign({ color: color, disabled: !props.playing, "aria-label": "Pause", onClick: props.onPauseClick }, (_g = props.PauseProps) === null || _g === void 0 ? void 0 : _g.attributes, { size: "large" }), ((_j = (_h = props.PauseProps) === null || _h === void 0 ? void 0 : _h.icons) === null || _j === void 0 ? void 0 : _j[0]) || react_1.default.createElement(icons_1.Pause, null)),
        react_1.default.createElement(IconButton_1.default, __assign({ color: color, disabled: props.playing, "aria-label": "Play", onClick: props.onPlayClick }, (_k = props.PlayProps) === null || _k === void 0 ? void 0 : _k.attributes, { size: "large" }), ((_m = (_l = props.PlayProps) === null || _l === void 0 ? void 0 : _l.icons) === null || _m === void 0 ? void 0 : _m[0]) || react_1.default.createElement(icons_1.Play, null)),
        props.forward !== undefined &&
            react_1.default.createElement(IconButton_1.default, __assign({ color: color, disabled: props.forward === false, "aria-label": "Forward", onClick: props.onForwardClick }, (_o = props.ForwardProps) === null || _o === void 0 ? void 0 : _o.attributes, { size: "large" }), ((_q = (_p = props.ForwardProps) === null || _p === void 0 ? void 0 : _p.icons) === null || _q === void 0 ? void 0 : _q[0]) || react_1.default.createElement(icons_1.Forward, null))));
};
exports.ControlKeys = ControlKeys;
//# sourceMappingURL=ControlKeys.js.map